﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;

namespace GrafoviBiblioteka
{
    struct GrafMatrica{
        public int n;
        public float[,] mat;
    }

    class Grafovi
    {
        public static GrafMatrica ucitajGraf(String putanja){
            String[] linije = File.ReadAllLines(putanja);
            GrafMatrica grafm;
            //dimenzija matrice
            grafm.n = linije.Length;
            grafm.mat = new float[grafm.n, grafm.n];
            for (int i = 0; i < linije.Length; i++)
            {
                //split razdvaja string na nekoliko novih stringova
                //koristi neki separator za razdvajanje npr. prazno mesto
                String[] vrednosti = linije[i].Split();
                for (int j = 0; j < vrednosti.Length; j++)
                    grafm.mat[i, j] = Convert.ToSingle(vrednosti[j]);
            }
            return grafm;
        }

        public static void ispisiGraf(GrafMatrica grafm)
        {
            for (int i = 0; i < grafm.n; i++)
            {
                for (int j = 0; j < grafm.n; j++)
                    Console.Write(grafm.mat[i, j] + "\t");
                Console.WriteLine();
            }
        }

        public static void obilazakUDubinu(GrafMatrica grafm, int i, bool[] obidjen)
        {
            //ako smo bili u ovom cvoru return
            if (obidjen[i])
                return;
            //postavljamo da smo obisli (ispisali)
            obidjen[i] = true;
            Console.WriteLine(i);
            //pozivamo rekurzivno za njegove susede
            for (int j = 0; j < grafm.n; j++)
                if (grafm.mat[i, j] == 1)
                    obilazakUDubinu(grafm, j, obidjen);
        }

        /* indeks je aktivni element u nizu
         * elemenata je broj upisanih elemenata u niz dosad
         * */
        public static void obilazakUSirinu(GrafMatrica grafm,  bool[] obidjen, int[] obilazak, int indeks, int elemenata){
            //ako smo stigli do kraja niza zavrsavamo
            if (indeks==elemenata)
                return;
            Console.WriteLine(obilazak[indeks]);
            obidjen[obilazak[indeks]] = true;
            //upisujemo sve susede od aktivnog elementa koji vec nisu obidjeni
            for (int j = 0; j < grafm.n; j++)
                if(grafm.mat[obilazak[indeks],j]==1 && !obidjen[j])
                    obilazak[elemenata++] = j;
            //pozivamo rekurziju za sledeci u nizu
            obilazakUSirinu(grafm, obidjen, obilazak, indeks + 1, elemenata);
        }
    }
}
